<template>
  <div class="routes" v-if="service && rule">
    <div class="routes__info">
      <p>
        {{ service.serviceTypeTitle }}. {{ service.resourceTitle ? service.resourceTitle+'.' : '' }} {{ service.serviceUnitTitle }}
      </p>
      <p>
        Период {{ period }}, подпериод: месяц
      </p>
    </div>
    <div class="routes-form">
      <h2>Направление</h2>
      <div class="routes-form__row">
        <obAddressInput
          :address="fromPoint.address.label"
          :prefixIcon="fromPoint.address.icon || ''"
          isLocationsOnly
          title="Откуда"
          placeholder="Начните вводить название начальной точки маршрута"
          required
          :showMap="false"
          :disabled="rule.titul.status !== 'DRAFT' && rule.titul.status !== 'STOPPED'"
          @input="setAddressFrom"
          isLocations
          data-qa="tms-distribution-address-from"
        />
      </div>
      <div class="routes-form__row">
        <obAddressInput
          :address="toPoint.address.label"
          :prefixIcon="toPoint.address.icon || ''"
          isLocationsOnly
          title="Куда "
          placeholder="Начните вводить название конечной точки маршрута"
          required
          :showMap="false"
          :disabled="rule.titul.status !== 'DRAFT' && rule.titul.status !== 'STOPPED'"
          @input="setAddressTo"
          isLocations
          data-qa="tms-distribution-address-to"
        />
      </div>
      <h2>Распределение по исполнителям</h2>
      <div class="routes-contractors">
        <div class="routes-contractors__row">
          <span>исполнители</span>
          <span>% распределено</span>
        </div>
        <div
          class="routes-contractors__row"
          v-for="(contractor, index) in selectedContractors"
          :key="index"
        >
          <ObInlineSelect
            v-model="contractor.uuid"
            :ref="`${index}distContractorSelect`"
            :items="contractors"
            :inheritWidth="false"
            :disabled="rule.titul.status !== 'DRAFT' && rule.titul.status !== 'STOPPED'"
            label="Выберите исполнителя"
            data-qa="tms-distribution-contractors"
          >
            <template v-slot="{ items }">
              <template v-if="items">
                <div
                  :class="['ob-inline-select__list-item', { top: item.top }]"
                  v-for="(item, idx) in filteredContractors"
                  :key="item.uuid"
                  :data-qa="'contractorSelect_' + idx"
                  @click="selectContractor(index, item, contractor)"
                >
                  <i :class="['icon', item.icon]" />
                  <div>
                    <div> {{ item.title }} </div>
                    <div v-if="item.inn" class="second-row">
                      {{ item.inn }}
                    </div>
                  </div>
                </div>
              </template>
            </template>
          </ObInlineSelect>
          <ObInput
            :class="contractor.isWrong ? 'is-wrong' : ''"
            v-model.number="contractor.value"
            :disabled="rule.titul.status !== 'DRAFT' && rule.titul.status !== 'STOPPED'"
            @input="checkValue(contractor)"
            data-qa="tms-contractor-value"
          />
          <div class="remove-contractor">
            <i class="icon close" v-if="index > 0" @click="removeContractor(index)"></i>
          </div>
        </div>
      </div>
      <div class="route-contractors-actions" v-if="rule.titul.status === 'DRAFT' || rule.titul.status === 'STOPPED'">
        <span class="add-contractor" :class="{disabled: isContractorsDisabled}" @click="addContractor">
          <i class="icon plus"></i>
          Добавить исполнителя
        </span>
        <p>
          Всего распределено:
          <span
            :class="[
              totalPercent > 100 ? 'error' : '',
              totalPercent === 100 ? 'full' : '',
            ]"
            >{{ totalPercent }}/100%</span
          >
        </p>
      </div>
      <div v-if="isNotification" class="route-contractors-notification">
          * Необходимо полностью распределить все перевозки на исполнителей
      </div>
    </div>
    <div class="routes__actions">
      <ob-button label="Сохранить" :disabled="!isFormReady" @click="onSave" />
      <ob-button label="Отмена" type="flat" @click="$emit('cancel')" />
      <!-- TODO one day we will need it 😀 -->
      <!-- <ob-menu-dropdown
        :items="[
          {
            title: 'Копировать',
            method: () => onCopy(),
          }
        ]"
        trigger="click"
      /> -->
    </div>
  </div>
</template>

<script>
import { mapActions, mapGetters } from 'vuex';
import { uuid } from "vue-uuid";
import api from "@/api";
import ObAddressInput from "common-components/src/obComponents/obAddressInput";
import ObInlineSelect from "common-components/src/obComponents/obInlineSelect";
import ObInput from "common-components/src/obComponents/obInput";
import ObButton from "common-components/src/obComponents/obButton";
// import ObMenuDropdown from "common-components/src/obComponents/obMenuDropdown";

export default {
  name: "distributionModal",

  components: {
    ObAddressInput,
    ObInlineSelect,
    ObInput,
    ObButton,
    // ObMenuDropdown,
  },

  props: {
    direction: {
      type: Object,
      default: () => ({})
    }
  },

  data() {
    return {
      bak: {
        fromPoint: '',
        toPoint: '',
        selectedContractors: []
      },
      fromPoint: {
        address: {
          label: "",
          coordinates: [],
          icon: "",
        },
        locationTitle: "",
        locationTypeIcon: "",
        locationUuid: "",
      },
      toPoint: {
        address: {
          label: "",
          coordinates: [],
          icon: "",
        },
        locationTitle: "",
        locationTypeIcon: "",
        locationUuid: "",
      },
      selectedContractors: [],
      contractors: [],
    };
  },

  computed: {
    ...mapGetters({
      rule: 'tms/rule'
    }),
    filteredContractors() {
      const data = this.contractors.reduce((acc, item) => {
        if (!this.selectedContractors.some(c => c.title === item.title)) {
          acc.push(item);
        }
        return acc;
      }, []);
      return data;
    },
    isContractorsDisabled() {
      return this.contractors.length === this.selectedContractors.length;
    },
    service() {
      return this.rule.services.find(item => item.uuid === this.$route.params.service);
    },
    period() {
      return `${new Date(this.rule.titul.applyFromD).toLocaleDateString('ru-RU')} - ${new Date(this.rule.titul.applyToD).toLocaleDateString('ru-RU')}`
    },
    totalPercent() {
      if (!this.selectedContractors.length) {
        return 0;
      }

      return this.selectedContractors.reduce(
        (acc, item) => acc + +item.value,
        0
      );
    },

    isFormReady() {
      if (this.rule.titul.status !== 'DRAFT' && this.rule.titul.status !== 'STOPPED') return false;

      return !!(this.fromPoint.address.label && this.toPoint.address.label && this.selectedContractors.length && this.selectedContractors[0].title.length && this.selectedContractors[0].value > 0 && this.totalPercent <= 100 && this.isFormDirty);
    },

    isFormDirty() {
      return this.bak.fromPoint !== JSON.stringify(this.fromPoint) || this.bak.toPoint !== JSON.stringify(this.toPoint) || this.bak.selectedContractors !== JSON.stringify(this.selectedContractors);
    },

    isNotification() {
      return this.totalPercent < 100;
    }
  },

  watch: {
    direction: {
      handler: function(newVal) {
        if (newVal) {
          this.fromPoint = newVal.fromPoint;
          this.toPoint = newVal.toPoint;
          this.selectedContractors = newVal.selectedContractors;
          this.bak.fromPoint = JSON.stringify(newVal.fromPoint);
          this.bak.toPoint = JSON.stringify(newVal.toPoint),
          this.bak.selectedContractors = JSON.stringify(newVal.selectedContractors);
        }
      },
      immediate: true
    }
  },

  async mounted() {
    const res = await api.tms.getDirectionContractors(this.service.uuid);
    this.contractors = res ? res : [];
  },

  methods: {
    ...mapActions({
      setRuleDirections: 'tms/setRuleDirections'
    }),

    // filteredContractors(items) {
    //   const data = items.reduce((acc, item) => {
    //     if (!this.selectedContractors.some(c => c.title === item.title)) {
    //       acc.push(item);
    //     }
    //     return acc;
    //   }, []);
    //   return data;
    // },

    setAddressFrom($event) {
      this.fromPoint.address = $event;
      this.fromPoint.locationTitle = $event.label;
      this.fromPoint.locationTypeIcon = $event.icon.toUpperCase();
      this.fromPoint.locationUuid = $event.locationUuid;
      if (!$event.icon) {
        this.fromPoint.address.icon = "pin";
      }
    },

    setAddressTo($event) {
      this.toPoint.address = $event;
      this.toPoint.locationTitle = $event.label;
      this.toPoint.locationTypeIcon = $event.icon.toUpperCase();
      this.toPoint.locationUuid = $event.locationUuid;
      if (!$event.icon) {
        this.toPoint.address.icon = "pin";
      }
    },

    addContractor() {
      this.selectedContractors.push({
        uuid: "",
        title: "",
        icon: "",
        value: 0,
        isWrong: false,
      });
    },

    removeContractor(index) {
      this.selectedContractors.splice(index, 1);
    },

    selectContractor(index, item, contractor) {
      contractor.title = item.title;
      const str = `${index}distContractorSelect`;
      this.$refs[str][0].select(item);
    },

    checkValue(contractor) {
      if (this.totalPercent > 100) {
        contractor.isWrong = true;
      } else {
        this.selectedContractors.forEach(contractor => {
          contractor.isWrong = false;
        })
      }
    },

    async onSave() {
      const newUuid = this.direction ? this.direction.uuid : uuid.v4();
      const participants = this.selectedContractors.map(item => {
        return {
          participantUuid: item.uuid,
          volume: item.value
        }
      })
      const payload = {
        distributionServiceUuid: this.service.uuid,
        fromLocationUuid: this.fromPoint.locationUuid,
        toLocationUuid: this.toPoint.locationUuid,
        participantVolumes: participants
      }

      try {
        await api.tms.saveDirections(newUuid, payload);
        this.reset();
        this.$emit('save')
      } catch (e) {
        console.error(e);
        this.$notification({
          type: "system_notification_error",
          message: "Ошибка при совершении операции"
        });
      }

      // this.setRuleDirections({
      //   route: {
      //     from: this.fromPoint,
      //     to: this.toPoint,
      //     contractors: this.selectedContractors
      //   }
      // })
    },

    reset() {
      this.fromPoint = {
        address: {
          label: "",
          coordinates: [],
          icon: "",
        },
        locationTitle: "",
        locationTypeIcon: "",
        locationUuid: "",
      };

      this.toPoint = {
        address: {
          label: "",
          coordinates: [],
          icon: "",
        },
        locationTitle: "",
        locationTypeIcon: "",
        locationUuid: "",
      };

      this.selectedContractors = [];

      this.bak = {
        fromPoint: JSON.stringify(this.fromPoint),
        toPoint: JSON.stringify(this.toPoint),
        selectedContractors: JSON.stringify(this.selectedContractors)
      }
    },

    //TODO one day we will need it 😀
    // onCopy() {
    //   console.log('copy');
    // }
  },
};
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/variables";
@import "~common-components/src/static/css/mixins";

.routes-form {
  h2 {
    margin-top: 30px;
    margin-bottom: 10px;
    @include font-mixin(20px, 28px, 700, $color-text-base, 0.4px);
  }
}

.routes-form__row {
  margin-top: 20px;
}

h2 + .routes-form__row {
  margin-top: 0;
}

.routes-contractors {
  @include font-mixin(11px, 12px, 400, $shale-gray, 0.4px);
  border: 1px solid $lavender;

  &::v-deep {
    .ob-input-wrap {
      width: 85px;
      height: 39px;
    }
  }
}

.routes-contractors__row {
  padding: 13px 0 13px 20px;
  display: flex;
  justify-content: space-between;
  align-items: center;

  &:first-child {
    padding: 13px 20px;
    text-transform: uppercase;
  }

  &:not(:last-child) {
    border-bottom: 1px solid $lavender;
  }
}

.ob-input-container {
  margin-left: auto;
}
.route-contractors-notification{
  text-align: right;
  color: $color-error;
}
.route-contractors-actions {
  padding: 13px 20px;
  display: flex;
  justify-content: space-between;
  color: $color-grey-span;

  .add-contractor {
    display: flex;
    align-items: center;
    @include font-mixin(14px, 16px, 400, $color-blue-smalt, 0.4px);
    cursor: pointer;

    i {
      margin-right: 3px;
      color: $color-grey-span;
    }
  }

  .add-contractor.disabled {
    color: $gray-slate;
    pointer-events: none;
  }
}

.remove-contractor {
  width: 39px;
  height: 39px;
  display: flex;
  justify-content: center;
  align-items: center;
  cursor: pointer;

  i {
    color: $color-grey-border;
  }
}

.ob-inline-select {
  @include font-mixin(14px, 20px, 400, $shale-gray, 0.4px);
}

.ob-inline-select__list-item {
  display: flex;
  align-items: flex-start;
  font-size: 14px;
  letter-spacing: 0.2px;
  color: #191e32;
  padding: 8px 16px;
  cursor: pointer;
  white-space: nowrap;

  &:first-child {
    padding-top: 16px;
  }
  &:last-child {
    padding-bottom: 16px;
  }

  &.top {
    border-bottom: 1px solid rgba(209, 210, 214, 0.3);
  }

  .icon {
    margin-right: 5px;
    color: #004bc8;
  }

  &:empty {
    display: none;
  }

  &:only-child {
    padding-top: 16px;
  }
  .second-row {
    color: #757884;
    font-size: 12px;
    margin-top: 1px;
  }
}

span.error {
  color: $color-error;
}

span.full {
  color: $color-green-light;
}

.routes__actions {
  margin-top: 37px;
  display: flex;
  align-items: center;
  gap: 20px;
}

.ob-menu-dropdown-container {
  margin-left: auto;
}

::v-deep {
  .is-wrong {
    .ob-input-wrap.--theme-default,
    .ob-input-wrap.--theme-default.--focused {
      border-color: $color-error;
    }
  }
}
</style>
